#include <typon/typon.hpp>
#include <cstdio>


using namespace typon;

int fibo(int n) {
  if (n < 2)
    return n;
  return fibo(n - 1) + fibo(n - 2);
}

Task<void> hello(int i) {
  int n = fibo(10);
  (void) i;
  (void) n;
  printf("hello from %d on %u, fibo(40) = %d\n", i, Scheduler::thread_id, n);
  co_return;
}

Join<void> parallel() {
  for (int i = 0; i < 30; i++) {
    co_await fork(hello(i));
    printf("parallel resumed on %u\n", Scheduler::thread_id);
  }
  printf("parallel syncing on %u\n", Scheduler::thread_id);
  co_await Sync();
  printf("parallel resumed on %u\n", Scheduler::thread_id);
  for (int i = 30; i < 60; i++) {
    co_await fork(hello(i));
    printf("parallel resumed on %u\n", Scheduler::thread_id);
  }
}

Root root() {
  co_await parallel();
  printf("root resumed on %u\n", Scheduler::thread_id);
}

int main() {
  root().call();
  puts("done");
  return 0;
}
